commit a365255bbaa9353e8c0299b75492bb51b3a507fe
Author: berryc <berryc>
Date:   Sun Jun 27 17:46:42 2010 +0000

    consolidated locale/client charset update

diff --git a/ChangeLog b/ChangeLog
index 4f18b67..7d1ce87 100644
--- a/ChangeLog
+++ b/ChangeLog
@@ -1,8 +1,13 @@
+Sun Jun 27 12:40:00 CDT 2010	Craig A. Berry <craigberry@mac.com>
+	* include/tds.h src/apps/tsql.c src/tds/iconv.c src/tds/locale.c
+	* src/tds/mem.c:
+	- consolidated locale/client charset update
+
 Sun Jun 27 07:58:00 CEST 2010    Frediano Ziglio <freddy77_A_gmail_D_com>
 	* Makefile.am configure.ac:
 	- honour vms/Makefile.am removing duplications
 
-Sat Jun 26 19:50:00 CEST 2010   Craig A. Berry <craigberry@mac.com>
+Sat Jun 26 19:50:00 CDT 2010   Craig A. Berry <craigberry@mac.com>
 	* Makefile.am, src/apps/defncopy.c, src/apps/fisql/fisql.c,
 	* src/apps/freebcp.c, vms/Makefile.am, vms/config_h.vms,
 	* vms/descrip_mms.template, vms/vargdefs.h, vms/vmsarg_command_bcp.cld,
@@ -2516,4 +2521,4 @@ Wed Jan  9 19:54:43 EST 2008	JK Lowden <jklowden@freetds.org>
 	* ChangeLog-0.82 added because of release
 	
 $FreeTDS$
-$Id: ChangeLog,v 1.3040 2010/06/27 05:58:09 freddy77 Exp $
+$Id: ChangeLog,v 1.3041 2010/06/27 17:46:42 berryc Exp $
diff --git a/include/tds.h b/include/tds.h
index c148806..ebedc0f 100644
--- a/include/tds.h
+++ b/include/tds.h
@@ -21,7 +21,7 @@
 #ifndef _tds_h_
 #define _tds_h_
 
-/* $Id: tds.h,v 1.336 2010/06/19 09:51:36 freddy77 Exp $ */
+/* $Id: tds.h,v 1.337 2010/06/27 17:46:43 berryc Exp $ */
 
 #include <stdarg.h>
 #include <stdio.h>
@@ -908,7 +908,6 @@ typedef struct tds_locale
 {
 	char *language;
 	char *server_charset;
-	char *client_charset;
 	char *date_fmt;
 } TDSLOCALE;
 
diff --git a/src/apps/tsql.c b/src/apps/tsql.c
index 26574fb..95c9b79 100644
--- a/src/apps/tsql.c
+++ b/src/apps/tsql.c
@@ -87,7 +87,7 @@
 #include "tdsconvert.h"
 #include "replacements.h"
 
-TDS_RCSID(var, "$Id: tsql.c,v 1.133 2010/04/08 08:19:16 freddy77 Exp $");
+TDS_RCSID(var, "$Id: tsql.c,v 1.134 2010/06/27 17:46:43 berryc Exp $");
 
 #define TDS_ISSPACE(c) isspace((unsigned char) (c))
 
@@ -297,7 +297,8 @@ static void
 tsql_print_usage(const char *progname)
 {
 	fprintf(stderr,
-		"Usage:\t%s [-S <server> | -H <hostname> -p <port>] -U <username> [-P <password>] [-I <config file>] [-o <options>] [-t delim] [-r delim] [-D database]\n"
+		"Usage:\t%s [-S <server> | -H <hostname> -p <port>] -U <username> [-P <password>]\n"
+		"\t\t[-I <config file>] [-J <client charset>] [-o <options>] [-t delim] [-r delim] [-D database]\n"
 		"\t%s -C\n"
 		"Options:\n"
 		"\tf\tDo not print footer\n"
@@ -402,23 +403,10 @@ populate_login(TDSLOGIN * login, int argc, char **argv)
 	char *confile = NULL;
 	int port = 0;
 	int opt;
-	const char *locale = NULL;
 	const char *charset = NULL;
 	char *opt_flags_str = NULL;
 
-	setlocale(LC_ALL, "");
-	locale = setlocale(LC_ALL, NULL);
-
-#if HAVE_LOCALE_CHARSET
-	charset = locale_charset();
-#endif
-#if HAVE_NL_LANGINFO && defined(CODESET)
-	if (!charset)
-		charset = nl_langinfo(CODESET);
-#endif
-
-
-	while ((opt = getopt(argc, argv, "H:S:I:P:U:p:Co:t:r:D:Lv")) != -1) {
+	while ((opt = getopt(argc, argv, "H:S:I:J:P:U:p:Co:t:r:D:Lv")) != -1) {
 		switch (opt) {
 		case 't':
 			opt_col_term = strdup(optarg);
@@ -452,6 +440,9 @@ populate_login(TDSLOGIN * login, int argc, char **argv)
 			free(confile);
 			confile = strdup(optarg);
 			break;
+		case 'J':
+			charset = strdup(optarg);
+			break;
 		case 'p':
 			port = atoi(optarg);
 			break;
@@ -495,16 +486,6 @@ populate_login(TDSLOGIN * login, int argc, char **argv)
 		}
 	}
 
-
-	if (locale)
-		if (!QUIET) printf("locale is \"%s\"\n", locale);
-	if (charset) {
-		if (!QUIET) printf("locale charset is \"%s\"\n", charset);
-	} else {
-		charset = "ISO-8859-1";
-		if (!QUIET) printf("using default charset \"%s\"\n", charset);
-	}
-	
 	if ((global_opt_flags & OPT_INSTANCES) && hostname) {
 		static const char template[] = "%s.instances";
 		char ip[24] = {'\0'};
@@ -582,7 +563,7 @@ populate_login(TDSLOGIN * login, int argc, char **argv)
 		tds_set_app(login, "TSQL");
 		tds_set_library(login, "TDS-Library");
 		tds_set_server(login, servername);
-		tds_set_client_charset(login, charset);
+		if (charset) tds_set_client_charset(login, charset);
 		tds_set_language(login, "us_english");
 		tds_set_passwd(login, password);
 		if (confile) {
@@ -595,7 +576,7 @@ populate_login(TDSLOGIN * login, int argc, char **argv)
 		tds_set_library(login, "TDS-Library");
 		tds_set_server(login, hostname);
 		tds_set_port(login, port);
-		tds_set_client_charset(login, charset);
+		if (charset) tds_set_client_charset(login, charset);
 		tds_set_language(login, "us_english");
 		tds_set_passwd(login, password);
 	}
@@ -681,6 +662,8 @@ main(int argc, char **argv)
 	pid_t timer_pid = 0;
 	int pipes[2];
 #endif
+	const char *locale = NULL;
+	const char *charset = NULL;
 
 	istty = isatty(0);
 
@@ -710,6 +693,32 @@ main(int argc, char **argv)
 	tds_set_parent(tds, NULL);
 	connection = tds_read_config_info(tds, login, context->locale);
 
+	setlocale(LC_ALL, "");
+	locale = setlocale(LC_ALL, NULL);
+
+#if HAVE_LOCALE_CHARSET
+	charset = locale_charset();
+#endif
+#if HAVE_NL_LANGINFO && defined(CODESET)
+	if (!charset)
+		charset = nl_langinfo(CODESET);
+#endif
+
+	if (locale)
+		if (!QUIET) printf("locale is \"%s\"\n", locale);
+	if (charset) {
+		if (!QUIET) printf("locale charset is \"%s\"\n", charset);
+	}
+	
+	if (tds_dstr_isempty(&connection->client_charset)) {
+		if (!charset)
+			charset = "ISO-8859-1";
+
+		tds_set_client_charset(login, charset);
+		tds_dstr_dup(&connection->client_charset, &login->client_charset);
+	}
+	if (!QUIET) printf("using default charset \"%s\"\n", tds_dstr_cstr(&connection->client_charset));
+
 	if (opt_default_db) {
 		tds_dstr_copy(&connection->database, opt_default_db);
 		if (!QUIET) fprintf(stderr, "Default database being set to %s\n", opt_default_db);
diff --git a/src/tds/iconv.c b/src/tds/iconv.c
index ff53b8a..2825f0d 100644
--- a/src/tds/iconv.c
+++ b/src/tds/iconv.c
@@ -49,7 +49,7 @@
 /* define this for now; remove when done testing */
 #define HAVE_ICONV_ALWAYS 1
 
-TDS_RCSID(var, "$Id: iconv.c,v 1.143 2010/02/08 12:16:43 freddy77 Exp $");
+TDS_RCSID(var, "$Id: iconv.c,v 1.144 2010/06/27 17:46:43 berryc Exp $");
 
 #define CHARSIZE(charset) ( ((charset)->min_bytes_per_char == (charset)->max_bytes_per_char )? \
 				(charset)->min_bytes_per_char : 0 )
@@ -440,12 +440,12 @@ tds_iconv_info_init(TDSICONV * char_conv, const char *client_name, const char *s
 	server_canonical = tds_canonical_charset(server_name);
 
 	if (client_canonical < 0) {
-		tdsdump_log(TDS_DBG_FUNC, "tds_iconv_info_init: client charset name \"%s\" unrecognized\n", client->name);
+		tdsdump_log(TDS_DBG_FUNC, "tds_iconv_info_init: client charset name \"%s\" unrecognized\n", client_name);
 		return 0;
 	}
 
 	if (server_canonical < 0) {
-		tdsdump_log(TDS_DBG_FUNC, "tds_iconv_info_init: server charset name \"%s\" unrecognized\n", client->name);
+		tdsdump_log(TDS_DBG_FUNC, "tds_iconv_info_init: server charset name \"%s\" unrecognized\n", server_name);
 		return 0;
 	}
 
diff --git a/src/tds/locale.c b/src/tds/locale.c
index a42ca8e..8190f36 100644
--- a/src/tds/locale.c
+++ b/src/tds/locale.c
@@ -22,6 +22,10 @@
 #include <config.h>
 #endif
 
+#if HAVE_LOCALE_H
+#include <locale.h>
+#endif
+
 #include <stdarg.h>
 #include <stdio.h>
 #include <ctype.h>
@@ -41,7 +45,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: locale.c,v 1.28 2007/10/16 15:12:22 freddy77 Exp $");
+TDS_RCSID(var, "$Id: locale.c,v 1.29 2010/06/27 17:46:43 berryc Exp $");
 
 
 static void tds_parse_locale(const char *option, const char *value, void *param);
@@ -68,12 +72,16 @@ tds_get_locale(void)
 	if (in) {
 		tds_read_conf_section(in, "default", tds_parse_locale, locale);
 
+#if HAVE_LOCALE_H
+		setlocale(LC_ALL, "");
+		s = setlocale(LC_ALL, NULL);
+#else
 		s = getenv("LANG");
+#endif
 		if (s && s[0]) {
 			int found;
 			char buf[128];
 			const char *strip = "@._";
-			const char *charset = NULL;
 
 			/* do not change environment !!! */
 			tds_strlcpy(buf, s, sizeof(buf));
@@ -96,19 +104,13 @@ tds_get_locale(void)
 				if (!s)
 					continue;
 				*s = 0;
-				if (*strip == '.')
-					charset = s+1;
 				rewind(in);
 				found = tds_read_conf_section(in, buf, tds_parse_locale, locale);
 			}
 
-			/* charset specified in LANG ?? */
-			if (charset) {
-				free(locale->client_charset);
-				locale->client_charset = strdup(charset);
-			}
 		}
 
+
 		fclose(in);
 	}
 	return locale;
diff --git a/src/tds/mem.c b/src/tds/mem.c
index 1977c19..4d2bdcd 100644
--- a/src/tds/mem.c
+++ b/src/tds/mem.c
@@ -53,7 +53,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: mem.c,v 1.198 2010/05/02 11:52:13 freddy77 Exp $");
+TDS_RCSID(var, "$Id: mem.c,v 1.199 2010/06/27 17:46:43 berryc Exp $");
 
 static void tds_free_env(TDSSOCKET * tds);
 static void tds_free_compute_results(TDSSOCKET * tds);
@@ -690,35 +690,9 @@ TDSLOCALE *
 tds_alloc_locale(void)
 {
 	TDSLOCALE *locale;
-#if !(HAVE_NL_LANGINFO && defined(CODESET))
-	char *lc_all;
-#endif
 
 	TEST_MALLOC(locale, TDSLOCALE);
 
-#if HAVE_NL_LANGINFO && defined(CODESET)
-	locale->client_charset = strdup(nl_langinfo(CODESET));
-#else
-	locale->client_charset = strdup("ISO-8859-1");
-	if (!locale->client_charset)
-		goto Cleanup;
-
-	if ((lc_all = strdup(setlocale(LC_ALL, NULL))) == NULL)
-		goto Cleanup;
-
-	if (strtok(lc_all, ".")) {
-		char *encoding = strtok(NULL, "@");
-		if (encoding) {
-			free(locale->client_charset);
-			locale->client_charset = strdup(encoding);
-		}
-	}
-	free(lc_all);
-#endif
-	if (!locale->client_charset)
-		goto Cleanup;
-	tdsdump_log(TDS_DBG_FUNC, "tds_alloc_locale(): initialized locale to \"%s\"\n", locale->client_charset? locale->client_charset : "NULL");
-
 	return locale;
 
       Cleanup:
@@ -832,6 +806,9 @@ tds_alloc_connection(TDSLOCALE * locale)
 {
 	TDSCONNECTION *connection;
 	char hostname[128];
+#if !(HAVE_NL_LANGINFO && defined(CODESET))
+	char *lc_all;
+#endif
 
 	TEST_MALLOC(connection, TDSCONNECTION);
 	tds_dstr_init(&connection->server_name);
@@ -854,9 +831,28 @@ tds_alloc_connection(TDSLOCALE * locale)
 		goto Cleanup;
 	connection->tds_version = TDS_DEFAULT_VERSION;
 	connection->block_size = 0;
-	/* TODO use system default ?? */
+
+	setlocale(LC_ALL, "");
+#if HAVE_NL_LANGINFO && defined(CODESET)
+	if (!tds_dstr_copy(&connection->client_charset, nl_langinfo(CODESET)))
+		goto Cleanup;;
+#else
 	if (!tds_dstr_copy(&connection->client_charset, "ISO-8859-1"))
 		goto Cleanup;
+
+	if ((lc_all = strdup(setlocale(LC_ALL, NULL))) == NULL)
+		goto Cleanup;
+
+	if (strtok(lc_all, ".")) {
+		char *encoding = strtok(NULL, "@");
+		if (encoding) {
+			if (!tds_dstr_copy(&connection->client_charset, encoding))
+				goto Cleanup;
+		}
+	}
+	free(lc_all);
+#endif
+
 	if (locale) {
 		if (locale->language)
 			if (!tds_dstr_copy(&connection->language, locale->language))
@@ -1154,7 +1150,6 @@ tds_free_locale(TDSLOCALE * locale)
 	free(locale->language);
 	free(locale->server_charset);
 	free(locale->date_fmt);
-	free(locale->client_charset);
 	free(locale);
 }
 

